/*
 * Modification History
 *
 * 2003-November-6   Jason Rohrer
 * Created.
 */



#ifndef FORMAT_UTILS_INCLUDED
#define FORMAT_UTILS_INCLUDED



/**
 * Formats a data size as a string with units.
 *
 * For example, the size 1024 would be formatted as "1.00 KiB".
 *
 * @param inSizeInBytes the size to format in bytes.
 *
 * @return a formatted string with scale-appropriate units (B, KiB, MiB, etc).
 *   Must be destroyed by caller.
 */
char *formatDataSizeWithUnits( unsigned long inSizeInBytes );



#endif
